//#define UNICODE
//#define _UNICODE
#include <windows.h>
#include <tchar.h>
#include <crtdbg.h>
#include <iostream>
#include <cstdlib>
#define TOSTR_IMPL(arg)         #arg
#define TOSTR(arg)              TOSTR_IMPL(arg)
#define COUNTOF(ary)            (sizeof(ary)/sizeof(ary[0]))

struct GETPROCADDRESS_ARGS;
bool RemoteGetProcAddress(HANDLE hTrgProcess, HMODULE hModule, LPCSTR lpProcName, DWORD* pReturn = NULL);
bool RemoteGetProcAddress(HANDLE hTrgProcess, const GETPROCADDRESS_ARGS* pArgs, DWORD* pReturn = NULL);
bool RemoteExportedFunction(HANDLE hTrgProcess, LPTHREAD_START_ROUTINE pThreadProc, DWORD* pReturn = NULL);

bool RemoteLoadLibrary(HANDLE hTrgProcess, LPCTSTR pszDllPath, DWORD* pReturn = NULL);
bool RemoteGetModuleHandle(HANDLE hTrgProcess, LPCTSTR pszDllPath, DWORD* pReturn = NULL);
bool RemoteFreeLibrary(HANDLE hTrgProcess, HMODULE hModule, DWORD* pReturn = NULL);
template <typename ThreadArg>
bool ExecuteRemoteAPI(HANDLE hTrgProcess,
                      LPTHREAD_START_ROUTINE pThreadProc,
                      ThreadArg threadArg,
                      DWORD* pReturn = NULL);
template <typename ThreadArg>
bool ExecuteRemoteAPI(HANDLE hTrgProcess,
                      LPTHREAD_START_ROUTINE pThreadProc,
                      ThreadArg* pThreadArgBase,
                      uintptr_t argSize,
                      DWORD* pReturn = NULL);


// entry
int _tmain(int argc, TCHAR* argv[])
{
  int result = 1;

  // ΏۃvZXJ
  DWORD dwPID = 0;
  if (argc == 1)
  {
    std::cout << "ΏۂɂvZXID(PID)͂Ă\n>";
    std::cin >> dwPID;
    std::cin.clear();
    std::cin.ignore(1024, '\n');
  }
  else
  {
    dwPID = _ttol(argv[1]);
  }

  // \[X̊mF
  HANDLE hProcess = ::OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwPID);
  HMODULE hMod = ::LoadLibrary(_T("__dll__.dll"));
  if (!hProcess)
  {
    std::cout << "Error " << ::GetLastError()
              << " : PID " << dwPID <<  " OpenProcessς" << std::endl;
    goto FINALLY;
  }
  if (!hMod)
  {
    std::cout << "Error " << ::GetLastError() << " : LoadLibraryς" << std::endl;
    goto FINALLY;
  }

  // HMODULEFullPath
  TCHAR dllFullPath[MAX_PATH];
  ::GetModuleFileName(hMod, dllFullPath, COUNTOF(dllFullPath));

  // [gvZXɂƂĂDLLnhĂ
  DWORD dwAPIResult = 0;
  bool bRet = RemoteGetModuleHandle(hProcess, dllFullPath, &dwAPIResult);
  if (!bRet)
  {
    std::cout << "Error " << ::GetLastError() << " : RemoteGetModuleHandleς" << std::endl;
    goto FINALLY;
  }

  // Load
  if (!dwAPIResult)
  {
    bRet = RemoteLoadLibrary(hProcess, dllFullPath, &dwAPIResult);  // FreeLibĂȂł
    if (!bRet || !dwAPIResult)
    {
      std::cout << "Error " << ::GetLastError() << " : RemoteLoadLibraryς" << std::endl;
      goto FINALLY;
    }
  }

  _ASSERTE(dwAPIResult && "[gvZXɂDLL̃nhmۃV}X^");
  _ASSERTE(::GetProcAddress(hMod, "ExportedFunction") && "֐GNX|[gĂȂ");


  // GetProc
  bRet = RemoteGetProcAddress(hProcess, (HMODULE)dwAPIResult, "ExportedFunction", &dwAPIResult);
  if (!bRet || !dwAPIResult)
  {
    std::cout << "Error " << ::GetLastError() << " : RemoteGetProcAddressς" << std::endl;
    goto FINALLY;
  }

  // GetProĉg킹
  bRet = RemoteExportedFunction(hProcess, (LPTHREAD_START_ROUTINE)dwAPIResult, &dwAPIResult);
  if (!bRet || !dwAPIResult)
  {
    std::cout << "Error " << ::GetLastError() << " : RemoteExportedFunctionς" << std::endl;
    goto FINALLY;
  }

  std::cout << "( ^_^)/ < I'm PID is " << dwAPIResult << std::endl;
  result = 0;

FINALLY:
  if (hProcess) ::CloseHandle(hProcess);
  if (hMod)     ::FreeLibrary(hMod);
  return result;
}



  /* GetProcAddress */

// [gXbhɓn\
typedef struct GETPROCADDRESS_ARGS
{
  typedef FARPROC (WINAPI* FGetProcAddress)(HMODULE, LPCSTR);

  FGetProcAddress fGetProcAddress;
  HMODULE hModule;
  TCHAR lpProcName[260];
} GETPROCADDRESS_ARGS;

namespace detail {

  // [gXbh
  static DWORD WINAPI RemoteGetProcAddressMain(LPVOID lpThreadParameter)
  {
    const GETPROCADDRESS_ARGS* pArgs = (GETPROCADDRESS_ARGS*)lpThreadParameter;
    return (DWORD)pArgs->fGetProcAddress(pArgs->hModule, pArgs->lpProcName);
  }
  static void dummy() {}

} /* detail */


// hProcess  hModule ֐ lpProcName 𓾂
bool RemoteGetProcAddress(HANDLE hTrgProcess, HMODULE hModule, LPCSTR lpProcName, DWORD* pReturn/* = NULL*/)
{
  GETPROCADDRESS_ARGS args = {
    (GETPROCADDRESS_ARGS::FGetProcAddress)::GetProcAddress(::GetModuleHandle(_T("kernel32.dll")), "GetProcAddress"),
    hModule,
    {0},
  };
  _ASSERTE(args.fGetProcAddress && "֐ĂȂ");
  ::lstrcpynA(args.lpProcName, lpProcName, COUNTOF(args.lpProcName));
  return RemoteGetProcAddress(hTrgProcess, &args, pReturn);
}

bool RemoteGetProcAddress(HANDLE hTrgProcess, const GETPROCADDRESS_ARGS* pArgs, DWORD* pReturn/* = NULL*/)
{
  // zAhXԂɎsR[hƕKvȕϐ̈쐬
  const SIZE_T procSize = (PBYTE)::detail::dummy - (PBYTE)::detail::RemoteGetProcAddressMain;
  void* pThreadProc = ::VirtualAllocEx(hTrgProcess, NULL, procSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
  if (!pThreadProc
   || !::WriteProcessMemory(hTrgProcess, pThreadProc, ::detail::RemoteGetProcAddressMain, procSize, NULL))
  {
    return false;
  }
  return ExecuteRemoteAPI(hTrgProcess, (LPTHREAD_START_ROUTINE)pThreadProc, pArgs, sizeof(GETPROCADDRESS_ARGS), pReturn);
}


  /* ExportedFunction */
bool RemoteExportedFunction(HANDLE hTrgProcess, LPTHREAD_START_ROUTINE pThreadProc, DWORD* pReturn/* = NULL*/)
{
  return ExecuteRemoteAPI(hTrgProcess, pThreadProc, 0, pReturn);
}




  /* ۏ؂API */

/* LoadLibrary */
bool RemoteLoadLibrary(HANDLE hTrgProcess, LPCTSTR pszDllPath, DWORD* pReturn/* = NULL*/)
{
  const DWORD dwSize = (::lstrlen(pszDllPath)+1) * sizeof(TCHAR);
  const LPTHREAD_START_ROUTINE pThreadProc = reinterpret_cast<LPTHREAD_START_ROUTINE>(
    ::GetProcAddress(::GetModuleHandle(_T("kernel32.dll")), TOSTR(LoadLibrary)));
  _ASSERTE(pThreadProc && "APIĂȂ");
  return ExecuteRemoteAPI(hTrgProcess, pThreadProc, pszDllPath, dwSize, pReturn);
}


/* GetModuleHandle */
bool RemoteGetModuleHandle(HANDLE hTrgProcess, LPCTSTR pszDllPath, DWORD* pReturn/* = NULL*/)
{
  const DWORD dwSize = (::lstrlen(pszDllPath)+1) * sizeof(TCHAR);
  const LPTHREAD_START_ROUTINE pThreadProc = reinterpret_cast<LPTHREAD_START_ROUTINE>(
    ::GetProcAddress(::GetModuleHandle(_T("kernel32.dll")), TOSTR(GetModuleHandle)));
  _ASSERTE(pThreadProc && "APIĂȂ");
  return ExecuteRemoteAPI(hTrgProcess, pThreadProc, pszDllPath, dwSize, pReturn);
}


/* FreeLibrary */
bool RemoteFreeLibrary(HANDLE hTrgProcess, HMODULE dwModule, DWORD* pReturn/* = NULL*/)
{
  const LPTHREAD_START_ROUTINE pThreadProc = reinterpret_cast<LPTHREAD_START_ROUTINE>(
    ::GetProcAddress(::GetModuleHandle(_T("kernel32.dll")), "FreeLibrary"));
  _ASSERTE(pThreadProc && "APIĂȂ");
  return ExecuteRemoteAPI(hTrgProcess, pThreadProc, dwModule, pReturn);
}




    /* hTrgProcessɑ΂ pReturn = pThreadProc(pThreadArgBase); s */

// nꂽpThreadArgBase̓|C^Ȃ̂ŉzAhXԂɃf[^]
template <typename ThreadArg>
bool ExecuteRemoteAPI(HANDLE hTrgProcess,
                      LPTHREAD_START_ROUTINE pThreadProc,
                      ThreadArg* pThreadArgBase,
                      uintptr_t argSize,
                      DWORD* pReturn/* = NULL*/)
{
  _ASSERTE(argSize && "0ĂƂ͂Ȃ");
  _ASSERTE((hTrgProcess && pThreadProc && pThreadArgBase) && "NULLn");

  // zAhXԂɃf[^̈쐬
  void* pThreadArg = ::VirtualAllocEx(hTrgProcess, NULL, argSize, MEM_COMMIT, PAGE_READWRITE);
  if (!pThreadArg) {
    return false;
  }

  bool bResult = false;

  // 쐬̈Ƀf[^]
  if (::WriteProcessMemory(hTrgProcess, pThreadArg, pThreadArgBase, argSize, NULL)) {
    // AhXlƂēn
    bResult = ExecuteRemoteAPI(hTrgProcess, pThreadProc,
                                reinterpret_cast<uintptr_t>(pThreadArg), pReturn);
  }
  ::VirtualFreeEx(hTrgProcess, pThreadArg, 0, MEM_RELEASE);
  return bResult;
}


// threadArg ͂̂܂܎󂯓nłA̒l
// hTrgProcessɑ΂pThreadProc(threadArg)[gs
template <typename ThreadArg>
bool ExecuteRemoteAPI(HANDLE hTrgProcess,
                      LPTHREAD_START_ROUTINE pThreadProc,
                      ThreadArg threadArg,
                      DWORD* pReturn/* = NULL*/)
{
  // CreateRemoteThread҂̃^CAEg[ms]
#if defined(_DEBUG)
  static const UINT LIMIT_TIME = 5000;
#else
  static const UINT LIMIT_TIME = 1500;
#endif /* _DEBUG */

  _ASSERTE((hTrgProcess && pThreadProc) && "NULLn");
  C_ASSERT(sizeof(ThreadArg) == sizeof(void*)); // CreateRemoteThreadɑfœnlł邱ƁI

#pragma warning(push)
#pragma warning(disable: 4312)  // 'reinterpret_cast' : 'ThreadArg' 傫TCY 'void *' ֕ϊ܂B
  // hTrgProcess̒ɃXbh
  HANDLE hThread = ::CreateRemoteThread(hTrgProcess, NULL, 0, pThreadProc,
                                        reinterpret_cast<void*>(threadArg), 0, NULL);
#pragma warning(pop)

  if (!hThread) {
    return false;
  }

  bool bResult = false;

  // hThreadVOi(I)ɂȂ܂ő҂
  // ܁[ɃbNɂȂ邱Ƃ̂INFINITE͌
  const DWORD dwRetCode = ::WaitForSingleObject(hThread, LIMIT_TIME);
  switch (dwRetCode) {
  case WAIT_TIMEOUT:  break;
  case WAIT_OBJECT_0: break;
  case WAIT_FAILED:   /* FALLTHROUGH */
  case WAIT_ABANDONED:/* FALLTHROUGH */
  default:
    ::CloseHandle(hThread);
    return bResult;
  }
  bResult = true;

  // Xbh(API)̖߂l𓾂悤
  if (pReturn) {
    if (!::GetExitCodeThread(hThread, pReturn)) {
      bResult = false;
    }
    if (*pReturn == STILL_ACTIVE
      && dwRetCode == WAIT_TIMEOUT) {
      ::TerminateThread(hThread, 1);
      bResult = false;
    }
  }
  ::CloseHandle(hThread);
  return bResult;
}

// EOF
